package com.fujitsu.interstage.javaee.jms.application ;

import javax.jms.* ;
import javax.naming.InitialContext ;
import javax.naming.NamingException ;

public class JMSProducer
{
	public static final String CONNECTION_FACTORY_NAME = "jms/ConnectionFactory001" ;
	public static final String CLIENT_ID = "\"\"" ;
	public static final int DEFAULT_ROUND = 1 ;

	private String connectionFactoryName = null ;
	private String clientID = null ;

	private ConnectionFactory connectionFactory = null ;
	private Connection connection = null ;
	private Session session = null ;

	public JMSProducer( )
	{
		this.connectionFactoryName = CONNECTION_FACTORY_NAME ;
		this.clientID = CLIENT_ID ;
	}

	public JMSProducer( String connectionFactoryName )
	{
		this.connectionFactoryName = connectionFactoryName ;
		this.clientID = CLIENT_ID ;
	}

	public JMSProducer( String connectionFactoryName, String clientID )
	{
		this.connectionFactoryName = connectionFactoryName ;
		this.clientID = clientID ;
	}

	public void run( int round )
		throws NamingException, JMSException
	{
		InitialContext initialContext = new InitialContext( ) ;
		connectionFactory = ( ConnectionFactory )initialContext.lookup( connectionFactoryName ) ;
		for( int i = 0 ; i < round ; i++ ) {
			System.out.println( "[JMSProducer] round " + ( i + 1 ) + " *****START*****" ) ;
			connection = connectionFactory.createConnection( ) ;
			try {
				// Exception here.
				connection.setClientID( clientID ) ;
				session = connection.createSession( false, Session.AUTO_ACKNOWLEDGE ) ;
			} catch( JMSException ex ) {
				throw ex ;
			} finally {
				connection.close( ) ;
			}
			System.out.println( "[JMSProducer] round " + ( i + 1 ) + " ***** END *****" ) ;
		}
	}

	private static void printUsage( )
	{
		System.out.println( "Usage : java com.fujitsu.interstage.javaee.jms.application.JMSProducer [round]" ) ;
	}

	public static void main( String[ ] args )
	{
		int round = DEFAULT_ROUND ;
		JMSProducer producer = null ;

		if( 0 != args.length ) {
			round = Integer.parseInt( args[ 0 ] ) ;
		}

		producer = new JMSProducer( ) ;
		try {
			producer.run( round ) ;
		} catch( Exception ex ) {
			ex.printStackTrace( ) ;
			System.exit( 2 ) ;
		}

		System.exit( 0 ) ;
	}
}
